Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.ka2ddo.yaac.io
Class PipedReader

    java.lang.Object
      java.io.Reader
          org.ka2ddo.yaac.io.PipedReader

All Implemented Interfaces:
  java.io.Closeable, java.lang.Readable

    public class PipedReader

extends java.io.Reader

Field Summary

Fields inherited from class java.io.Reader
`lock`

Constructor Summary
`PipedReader(PipedWriter src, int pipeSize)` Creates a `PipedReader` so that it is connected to the piped writer `src` and uses the specified pipe size for the pipe's buffer.

Method Summary
`void` | `clearStatistics()` Reset the statistics counters.
`void` | `close()` Closes this piped stream and releases any system resources associated with the stream.
`void` | `connect(PipedWriter src)` Causes this piped reader to be connected to the piped writer `src`.
`int` | `getNumEmpty()` Report the number of times the pipe was found empty.
`int` | `getNumFull()` Report the number of times the pipe was found full.
`long` | `getWaitOnEmpty()` Report the number of milliseconds spent waiting on an empty pipe.
`long` | `getWaitOnFull()` Report the number of milliseconds spent waiting on a full pipe.
`int` | `read()` Reads the next character of data from this piped stream.
`int` | `read(char[] cbuf, int off, int len)` Reads up to `len` characters of data from this piped stream into an array of characters.
`boolean` | `ready()` Tell whether this stream is ready to be read.

Methods inherited from class java.io.Reader
`mark, markSupported, read, read, reset, skip`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### PipedReader

    public PipedReader(PipedWriter src,
                       int pipeSize)
                throws java.io.IOException

  Creates a `PipedReader` so that it is connected to the piped writer `src` and uses the specified pipe size for the pipe's buffer. Data written to `src` will then be available as input from this stream.

  Parameters:
    `src` - the stream to connect to.
    `pipeSize` - the size of the pipe's buffer.
  Throws:
    `java.io.IOException` - if an I/O error occurs.
    `java.lang.IllegalArgumentException` - if `pipeSize <= 0`.

Method Detail

### connect

    public void connect(PipedWriter src)
                 throws java.io.IOException

  Causes this piped reader to be connected to the piped writer `src`. If this object is already connected to some other piped writer, an `IOException` is thrown.

  If `src` is an unconnected piped writer and `snk` is an unconnected piped reader, they may be connected by either the call:

      snk.connect(src)

  or the call:

      src.connect(snk)

  The two calls have the same effect.

  Parameters:
    `src` - The piped writer to connect to.
  Throws:
    `java.io.IOException` - if an I/O error occurs.

### read

    public int read()
             throws java.io.IOException

  Reads the next character of data from this piped stream. If no character is available because the end of the stream has been reached, the value `-1` is returned. This method blocks until input data is available, the end of the stream is detected, or an exception is thrown.

  Overrides:
    `read` in class `java.io.Reader`
  Returns:
    the next character of data, or `-1` if the end of the stream is reached.
  Throws:
    `java.io.IOException` - if the pipe is `broken`, `unconnected`, closed, or an I/O error occurs.

### read

    public int read(char[] cbuf,
                    int off,
                    int len)
             throws java.io.IOException

  Reads up to `len` characters of data from this piped stream into an array of characters. Less than `len` characters will be read if the end of the data stream is reached or if `len` exceeds the pipe's buffer size. This method blocks until at least one character of input is available.

  Specified by:
    `read` in class `java.io.Reader`
  Parameters:
    `cbuf` - the buffer into which the data is read.
    `off` - the start offset of the data.
    `len` - the maximum number of characters read.
  Returns:
    the total number of characters read into the buffer, or `-1` if there is no more data because the end of the stream has been reached.
  Throws:
    `java.io.IOException` - if the pipe is `broken`, `unconnected`, closed, or an I/O error occurs.

### ready

    public boolean ready()
                  throws java.io.IOException

  Tell whether this stream is ready to be read. A piped character stream is ready if the circular buffer is not empty.

  Overrides:
    `ready` in class `java.io.Reader`
  Throws:
    `java.io.IOException` - if the pipe is `broken`, `unconnected`, or closed.

### close

    public void close()
               throws java.io.IOException

  Closes this piped stream and releases any system resources associated with the stream.

  Specified by:
    `close` in interface `java.io.Closeable`
  Specified by:
    `close` in class `java.io.Reader`
  Throws:
    `java.io.IOException` - if an I/O error occurs.

### getNumEmpty

    public int getNumEmpty()

  Report the number of times the pipe was found empty.

  Returns:
    empty count

### getWaitOnEmpty

    public long getWaitOnEmpty()

  Report the number of milliseconds spent waiting on an empty pipe.

  Returns:
    wait time in milliseconds

### getNumFull

    public int getNumFull()

  Report the number of times the pipe was found full.

  Returns:
    full count

### getWaitOnFull

    public long getWaitOnFull()

  Report the number of milliseconds spent waiting on a full pipe.

  Returns:
    wait time in milliseconds

### clearStatistics

    public void clearStatistics()

  Reset the statistics counters.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD